<template>
        <v-layout row wrap>
            <v-flex
                    grow
                    pa-1
                    xs12
                    lg8
            >
                <h1 class="mt-1 display-1">Viimased 3 hääletust</h1>
                <v-slide-y-transition
                        class="py-0 ma-0"
                        group
                >
                    <v-alert key="alert" type="warning" :value="getLastVotes.length === 0">Hääletused puuduvad!</v-alert>
                    <vote v-for="(vote, index) in getLastVotes"
                          v-if="!vote.add"
                          :key="vote.id"
                          :id="vote.id"
                          :title="vote.title"
                          :description="vote.description"
                          :yes="positiveVotes(vote.id)"
                          :no="negativeVotes(vote.id)"
                          :img="vote.img"
                          :created_at="vote.created_at"
                          :created_by="vote.created_by_user"
                    ></vote>

                </v-slide-y-transition>
                <v-expand-transition>
                    <v-progress-linear v-show="isVotesLoading" :indeterminate="true" class="mb-0"></v-progress-linear>
                </v-expand-transition>
            </v-flex>

            <v-flex
                    grow
                    pa-1
                    class="hidden-xs-only"
            >
                <v-card color="rgba(230,230,250, 0.5)">
                    <v-card-text>Õpilasesinduses on liikmeid <span class="blue--text">{{ this.moderatorCount }}</span></v-card-text>
                    <v-progress-linear v-show="isLoading === true" :indeterminate="true"></v-progress-linear>
                    <v-divider v-show="isLoading === false"></v-divider>
                    <v-card-text>Õpilasesindussse on kandideerinud <span class="blue--text">{{ this.candidateCount }}</span> inimest</v-card-text>
                    <v-progress-linear v-show="isLoading === true" :indeterminate="true"></v-progress-linear>
                    <v-divider v-show="isLoading === false"></v-divider>
                    <v-card-text>Lehel on kasutajaid <span class="blue--text">{{ this.userCount }}</span></v-card-text>
                    <v-progress-linear v-show="isLoading === true" :indeterminate="true"></v-progress-linear>
                    <v-divider v-show="isLoading === false"></v-divider>
                    <v-card-text>Hääletusi on kokku <span class="blue--text">{{ this.votesCount }}</span></v-card-text>
                </v-card>
            </v-flex>
            <v-flex
                    grow
                    pa-1
                    ma-1
                    class="hidden-sm-and-up"
            >
                <v-card color="rgba(230,230,250, 0.5)">
                    <v-card-text>Õpilasesinduses on liikmeid <span class="blue--text">{{ this.moderatorCount }}</span></v-card-text>
                    <v-progress-linear v-show="isLoading === true" :indeterminate="true"></v-progress-linear>
                    <v-divider v-show="isLoading === false"></v-divider>
                    <v-card-text>Õpilasesindussse on kandideerinud <span class="blue--text">{{ this.candidateCount }}</span> inimest</v-card-text>
                    <v-progress-linear v-show="isLoading === true" :indeterminate="true"></v-progress-linear>
                    <v-divider v-show="isLoading === false"></v-divider>
                    <v-card-text>Lehel on kasutajaid <span class="blue--text">{{ this.userCount }}</span></v-card-text>
                    <v-progress-linear v-show="isLoading === true" :indeterminate="true"></v-progress-linear>
                    <v-divider v-show="isLoading === false"></v-divider>
                    <v-card-text>Hääletusi on kokku <span class="blue--text">{{ this.votesCount }}</span></v-card-text>
                </v-card>
            </v-flex>
        </v-layout>
</template>

<script>
    import {mapGetters} from "vuex";
    import Vote from "../components/Vote";

    export default {
        name: "Home",

        components: {
            Vote
        },

        data() {
            return {
                moderatorCount: '',
                candidateCount: '',
                userCount: '',
                votesCount: '',
                isVotesLoading: false,
            }
        },
        computed: {
            ...mapGetters('voting', {
                getLastVotes: 'last',
                positiveVotes: 'positiveVotes',
                negativeVotes: 'negativeVotes',
            }),
        },
        created() {
            this.isLoading = true;
            axios.get('api/sidebarInfo').then(response => {
                this.moderatorCount = response.data.moderatorCount;
                this.candidateCount = response.data.candidateCount;
                this.userCount = response.data.userCount;
                this.votesCount = response.data.votesCount;
                this.isLoading = false;
            });

            this.isVotesLoading = true;
            this.$store.dispatch('voting/loadLast')
                .then(() => this.isVotesLoading = false);
        },
    }
</script>

<style scoped>
.bottom {
    position: absolute;
    bottom: 0;
    left: 0;
    width: 100%;
}
</style>